package models

import (
	"context"

	"quyun/v2/pkg/consts"

	"github.com/samber/lo"
	"golang.org/x/crypto/bcrypt"
	"gorm.io/gorm"
)

func (m *User) ComparePassword(ctx context.Context, password string) bool {
	err := bcrypt.CompareHashAndPassword([]byte(m.Password), []byte(password))
	return err == nil
}

func (m *User) HasRole(ctx context.Context, role consts.Role) bool {
	return lo.Contains(m.Roles, role)
}

// BeforeCreate
func (m *User) BeforeCreate(tx *gorm.DB) error {
	bytes, err := bcrypt.GenerateFromPassword([]byte(m.Password), bcrypt.DefaultCost)
	if err != nil {
		return err
	}
	m.Password = string(bytes)

	return nil
}
